<?php


/*
* Include uploads upload class file
*/
require_once ($_CONF['path'] . 'plugins/uploads/Upload.class.php');


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+


/**
*
* Geeklog is checking to see if this plugin supports comments.
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_uploads()
{
    return false;
}

/**
* Returns the user option for this plugin
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
function plugin_getuseroption_uploads()
{
    global $_CONF;

    if (SEC_hasRights('uploads.admin')) {
        return array('Uploads', $_CONF['site_url'] . '/uploads/index.php');
    }
}

/**
* Return the current version of code. 
* Used in the Plugin Editor to show the registered version and code version
*/
function plugin_chkVersion_uploads()
{
    return '0.3';
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_uploads($installCheck='')
{
    global $_TABLES;

    $pi_name = 'uploads';
    $FEATURES = array ( 'uploads.admin');
    //$TABLES = array ('albums','media','settings','watermarks','exif','lookup');
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display = COM_siteHeader();
        $display .= COM_startBlock('Warning! Plugin is still Enabled');
        $display .= 'Disable plugin before uninstalling.';
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        echo $display;
        exit;
    }
        
    // Ok to proceed and delete plugin -- Unregister the plugin with Geeklog
    COM_errorLog("Attempting to unregister the $pi_name plugin from Geeklog",1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = '{$pi_name}'",1);
/*
    // Drop plugin tables
    foreach($TABLES as $table) {
        $t = $INM_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }
*/
    //remove plugin's blocks created by install
    //COM_errorLog("Removing $pi_name blocks",1);
    //DB_query("DELETE FROM {$_TABLES['blocks']} WHERE name='inmrandom' LIMIT 1",1);

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
    return true;
}

//returns "powered by"
function ups_poweredBy(){
    global $LANG_INM01;
    $retval = '<p style="text-align: center; font-size: .8em;">';
    $retval .= 'Uploads powered by Inmemoriam Media -- Courtesy SummitPages.ca';
    $retval .= '</p>';
    return $retval;
}

//put file sizes into readable form
//returns readable form or false
function ups_readbytes($bytes){
    $bytes = trim($bytes);
    $kb = 1024;
    $mb = 1024 * $kb;
    $gb = 1024 * $mb;
    $tb = 1024 * $gb;

    if ($bytes < $kb) {
        $bytes = "$max_file_size Bytes";
    } elseif ($bytes < $mb) {
        $final = round($bytes/$kb,2);
        $bytes = "$final KB";
    } elseif ($bytes < $gb) {
        $final = round($bytes/$mb,2);
        $bytes = "$final MB";
    } elseif($bytes < $tb) {
        $final = round($bytes/$gb,2);
            $bytes = "$final GB";
    } else {
        $final = round($bytes/$tb,2);
        $bytes = "$final TB";
    }
    return $bytes;
}

//converts M to bytes
function ups_returnBytes($val) {
   $val = trim($val);
   $last = strtolower($val{strlen($val)-1});
   switch($last) {
       // The 'G' modifier is available since PHP 5.1.0
       case 'g':
           $val *= 1024;
       case 'm':
           $val *= 1024;
       case 'k':
           $val *= 1024;
   }
   return $val;
}

//uploads a file
//returns a HTML string to copy and paste
//or an error msg
function ups_uploadFile(){
    global $_CONF, $_FILES;

    $filename = trim(strtolower($_FILES['userfile']['name']));
    if (!empty($filename)){
        //vars to upload class
        $newfile = new clccUpload;
        $newfile->temp_file_name = trim($_FILES['userfile']['tmp_name']);
        $newfile->file_name = $filename;
        $newfile->upload_dir = $_CONF['path_html'] . 'media/';
        $newfile->upload_log_dir = $_CONF['path_html'] . 'uploads/logs/';
        $maxfilesize = ups_returnBytes(ini_get('post_max_size'));
        $newfile->max_file_size = $maxfilesize;
        $newfile->ext_array = array('.jpg','.jpeg','.gif','.png','.pdf','.mp3','.wav');;

        //validate file
        $valid_ext = $newfile->validate_extension();
        $valid_size = $newfile->validate_size();
        $max_size = $newfile->get_max_size();
        $file_size = $newfile->get_file_size();
        $file_exists = $newfile->existing_file();
        if ($file_exists){
            //check file exists in dir
            $retval = '<p><b><i>' . $filename . '</b></i> exists on server -- please try again.</p>';
        } elseif (!$valid_ext){
            //check extension
            $retval = '<p><b><i>' . $filename . '</b></i> does not have an acceptable extension -- please try again.</p>';
        } elseif (!$valid_size){
            //check filesize
            $retval = '<p><b><i>' . $filename . '</b></i> exceeds acceptable file size limit, which at the moment is ' . $max_size . ' -- please try again.</p>';
        } else {
            //upload file
            $uploaded_file = $newfile->upload_file_with_validation();
            if (!$uploaded_file){
                $retval = '<p><b><i>' . $filename . '</b></i> could not be uploaded -- please try again.</p>';
            } else {
                //format HTML link text, etc.
                $retval = '<p><span style="color:red;font-weight:bold;">Copy and Paste</span> the following HTML code into your site\'s content.</p>';
                $retval .= "<div style=\"font-family: Courier, monospace; font-size: .85em; padding:10px; text-align: center; border: 1px solid black; background-color: #CCC;\">";
                $extension = strtolower(strrchr($filename,"."));
                switch ($extension){
                case '.mp3':
                    $str = '<a href="' . $_CONF['site_url'] . '/media/' . $filename . '">Insert Link Text Here</a>';
                    break;
                case '.wav':
                    $str = '<a href="' . $_CONF['site_url'] . '/media/' . $filename . '">Insert Link Text Here</a>';
                    break;
                case '.pdf':
                    $str = '<a href="' . $_CONF['site_url'] . '/media/' . $filename . '">Insert Link Text Here</a>';
                    break;
                default:
                    $str = '<img src="' . $_CONF['site_url'] . '/media/' . $filename . '" alt="Insert Alternate Text Here" />';
                }
                $retval .= htmlentities($str);
                $retval .= '</div><br /><br />';
            }
        }
    } else $retval = '<p>No file specified.  Please include the file you wish to upload.</p>';
    return $retval;
}

//scans media dir and returns extant files
function ups_scanDir(){
    global $_CONF;

    $mediadir = $_CONF['path_html'] . 'media/';
    if (is_dir($mediadir)){
        if ($dh = @opendir($mediadir)){
            $retval = '<p>This is a list of all files currently residing in the Uploads media directory.</p>';
            $retval .= '<ul style="list-style-position:inside;">';
           //loop thru dir for files only
           $i = 0;
           while (($file = @readdir($dh)) !== false) {
               if (filetype($mediadir . $file) == 'file' && $file != '.' && $file != '..'){
                   $filesize = ups_readbytes(filesize($mediadir . $file));
                   $retval .= '<li><b>Filename</b>:' . $file . '&nbsp;&nbsp;&nbsp;<b>size</b>:' . $filesize . '</li>';
                   $i++;
               }
           }
           $retval .= '</ul>';
           clearstatcache();
           closedir($dh);
           if ($i <= 0){
               $retval = 'No files exist in ' . $mediadir;
           }
        } else $retval = $mediadir . ' is not available.';
    } else $retval = $mediadir . ' is not available.';
    return $retval;
}
?>